//
//  Misc Gadgets
//  guit GUI Toolkit
//  Copyright © 2019 Eric Lecolinet. All rights reserved.
//  http://www.telecom-paristech.fr/~elc
//

#include <guit.hpp>
#include "examples.hpp"
using namespace std;
using namespace guit;

class Threads : public GWindow {
  GListBox lb;
  GInt callnbr, duration{2000}, value;

  void doCalc() {
    auto& status = Text();
    auto& it = Item(".calc_item");

    // performs operations in the main thread (needed because the GUI can
    // only be modified in the main thread)
    gexec([&]{
      callnbr++;
      status = "<bg:red><c:white>  Working...  </c>";
      it << ("Calculation #" + callnbr.stringValue() + ": " + ~status);
      lb << it;
    });

    // whatever long operation, here just waiting for duration msec
    gsleep(duration);

    gexec([&]{
      value++;
      status = "<bg:green><c:white>  Done!  ";
    });
  }
  
public:
  Threads() : GWindow("#threads Threads") {

    auto& controls = VBox("#controls")
    << ("<big>Computed Value: <c:red>" + ~value)
    << (HBox()
        << "Duration: "
        << (TextField("#duration") << duration)
        << "ms"
        )
    << (Button("<big>Start Calculation")
        << CallThread( [&]{doCalc();} )    // doCalc is called in a thread
        );

    *this
    << "#title Parallel Calls"
    << ("Each calculation sleeps for " + ~duration +"ms then adds 1 to the value")
    << (ScrollBox << lb)
    << controls;
  }
};


GWindow& Examples::makeThreads() {
  return *new Threads;
}
